<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Arroway!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>OO szemlélet</title>
        <para><emphasis>A módosított polártranszformációs normális generátor beprogramozása Java
                nyelven. Mutassunk rá, hogy a mi természetes saját megoldásunk (az algoritmus
                egyszerre két normálist állít elő, kell egy példánytag, amely a nem visszaadottat
                tárolja és egy logikai tag, hogy van-e tárolt vagy futtatni kell az algot.) és az
                OpenJDK, Oracle JDK-ban a Sun által adott OO szervezés ua.!</emphasis></para>
        <para><emphasis>Ugyanezt írjuk meg C++ nyelven is! (lásd még UDPROG repó:
                source/labor/polargen) </emphasis></para>
        <para> Megoldás forrása: <link
                xlink:href="https://arato.inf.unideb.hu/batfai.norbert/UDPROG/deprecated/Prog1_5.pdf"
            /> (16-22 fólia)</para>
        <para> Az objektumorientált programozás már nem ismeretlen a könyv olvasójának, hiszen már
            volt egyszer erről szó, most csak kicsit felfrissítjük az ismereteinket ezzel
            kapcsolatban, hiszen egy nagyon fontos tudnivalója annak, aki igazán jó programozó
            szeretne lenni. Ez a módszer segít abban, hogy egy program átlátható legyen, a
            megbízhatóságát és hatékonyságát növeljük. De hogyan is képzeljünk el egy ilyen
            objektumorientált programot? Nézzünk rá egy egyszerű példát! </para>
        <para>Van egy iskola, ezen belül járnak diákok és tanárok is, amikhez tartoznak olyan
            adatok, mint név, születési dátum, nem, a diákoknál az egyes tárgyakhoz jegyek, a
            tanárokhoz pedig a bér. Ezeket rendszerezve látjuk, és átláthatóbban tudunk ezekkel az
            adatokkal dolgozni. Lehet elsőnek nehéznek és bonyolultnak tűnik, de valójában némi
            gyakorlás, rutin segítségével könnyedén sajátunknak érezhetjük ezt a módszert. Muszáj
            is, ha az ember Java nyelven szeretne programozni, ami köztudottan egy OOP nyelv.
            Folytassuk is hát a feladattal, vagyis valósítsuk meg a polártranszformációs generátort.
            <programlisting language="java">public class PolárGenerátor {
	
    boolean nincsTárolt = true;
    double tárolt;
    
    public PolárGenerátor() {
        nincsTárolt = true;
    }

    public double következő() {
        
        if(nincsTárolt) {
            
            double u1, u2, v1, v2, w;
            do {
                u1 = Math.random();
                u2 = Math.random();
                
                v1 = 2*u1 - 1;
                v2 = 2*u2 - 1;
                
                w = v1*v1 + v2*v2;
                
            } while(w > 1);
            
            double r = Math.sqrt((-2*Math.log(w))/w);
            
            tárolt = r*v2;
            nincsTárolt = !nincsTárolt;
            
            return r*v1;
            
        } else {
            nincsTárolt = !nincsTárolt;
            return tárolt;
        }
    }
	public static void main(String[] args) {
	        PolárGenerátor g = new PolárGenerátor();
	        
	        for(int i=0; i&lt;10; ++i)
	            System.out.println(g.következő());

	}
}</programlisting></para>
        <para>
            <programlisting>    boolean nincsTárolt = true;
    double tárolt;
    
    public PolárGenerátor() {
        nincsTárolt = true;
    }</programlisting>
        </para>
        <para>Elsőnek is a <varname>PolárGenerátor</varname> pubklikus osztályunkban létrehozunk egy
            igaz-hamis változót, vagyis egy logikai tagot, ami a <varname>nincsTárolt</varname>
            nevet kapta, és igaz értékkel láttuk el. Ő mondja meg, hogy keletkezett-e tárolt érték,
            vagy sem. Illetve létrehoztuk a <varname>tárolt</varname> double típusú példánytagunkat
            is, ez lesz azaz értékünk, ami a számot fogja tartalmazni, amit kiszámol a program, ezt
            küldjük majd valójában a <function>main</function>-be. </para>
        <para>
            <programlisting>    public double következő() {
        
        if(nincsTárolt) {
            
            double u1, u2, v1, v2, w;
            do {
                u1 = Math.random();
                u2 = Math.random();
                
                v1 = 2*u1 - 1;
                v2 = 2*u2 - 1;
                
                w = v1*v1 + v2*v2;
                
            } while(w > 1);
            
            double r = Math.sqrt((-2*Math.log(w))/w);
            
            tárolt = r*v2;
            nincsTárolt = !nincsTárolt;
            
            return r*v1;
            
        } else {
            nincsTárolt = !nincsTárolt;
            return tárolt;
        }
    }</programlisting>
        </para>
        <para>Létrehozzuk a <function>következő()</function> függvényt is, ami magát a random
            generálást, illetve a kiszámítást fogja elvégezni, és később ezt fogjuk meghívni majd a
                <function>main</function>-ben. Ez if utasítást tartalmaz, aminek feltétele, hogy a
                <varname>nincsTárolt</varname> igaz legyen. Ha ez teljesül, akkor generál két
            számot, az <varname>u1</varname> és <varname>u2</varname>-t. Ezután egyértelműen a matek
            oldala történik, tehát például a <varname>v1</varname> az az <varname>u1</varname>
            kétszerese, amiből kivonunk egyet. Végül az így kapott <varname>v1</varname> és
                <varname>v2</varname> értékek négyzete lesz a <varname>w</varname> változó.
            Kiszámoljuk az <varname>r</varname>-t is, és így meg is lesz a két számunk. Az egyik a
            tárolt, az <varname>r</varname> és <varname>v2</varname> szorzata, amit pedig visszaad a
            generátor, az a <varname>r</varname> és a <varname>v1</varname> szorzata. Amennyiben a a
                <varname>nincsTárolt</varname> hamis lenne, ez az algoritmus nem fog lefutni. </para>
        <para>
            <programlisting>	public static void main(String[] args) {
	        PolárGenerátor g = new PolárGenerátor();
	        
	        for(int i=0; i&lt;10; ++i)
	            System.out.println(g.következő());

	}</programlisting>
        </para>
        <para>És a program végén van a <function>main</function>, amiben létrehozzuk a
                <code>PolárGenerátor</code> típusú <varname>g</varname> változót, ebbe rakjuk be a
            kapott számot, mikor egy 10-szer leforduló for ciklusban hívjuk meg a
                <function>következő()</function> függvényünket. Íme az eredmény, mit is kapunk
            akkor, ha ezt a programot lefuttatjuk: </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="1.2.1csokor/polar-java.png" scale="90"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
        <para>A polártranszformációs normális generátor C++ változata, ennek elemzése viszont már
            korábban volt, a könyvben a Welch fejezet első feladatában található. Viszont egy rövid
            összefoglalóval átismétlejük ezt a változatot is, hiszen vannak némi különbségek a
            Java-s és a C++-os változat között, de ezek főleg a nyelvi szintaxis miatt van. </para>
        <para>
            <programlisting language="c++"><![CDATA[#include <iostream>
#include <cstdlib>	
#include <cmath>	
#include <ctime>	

class Random {
	public:
		Random();
		~Random(){}
		double get();
	private:
		bool exist;
		double value; 
};

Random::Random() {
	exist = false;
	std::srand (std::time(NULL));
};

double Random::get() {
	if (!exist) {
		double u1, u2, v1, v2, w;
		do {
			u1 = std::rand () / (RAND_MAX + 1.0);
			u2 = std::rand () / (RAND_MAX + 1.0);
			v1 = 2 * u1 - 1;
			v2 = 2 * u2 - 1;
			w = v1 * v1 + v2 * v2;
		    }
		while (w > 1);
		double r = std::sqrt ((-2 * std::log (w)) / w);
		value = r * v2; 
		exist = !exist;
		return r * v1;
	}
	else {
		exist = !exist;
		return value;
	}
};

int main() {
    Random rnd;
    for (int i = 0; i < 10; ++i)
    std::cout << rnd.get() << std::endl; 
}]]></programlisting>
        </para>
        <para>
            <programlisting>class Random {
	public:
		Random();
		~Random(){}
		double get();
	private:
		bool exist;
		double value; 
};</programlisting>
        </para>
        <para>A <classname>Random</classname> osztályban megjelöljük a konstruktort, a
            dekonstruktort és a <code>get</code>-et, amivel lekérdezzük majd az adatainkat. Ezek
            nyilvánosak, hogy a <function>main</function>-ből is elérhetőek lehessenek. Illetve kell
            ugyebár a két példányunk, az egyik az <varname>exist</varname>, ami a logikai tagunk, ő
            fogja megmondani, hogy van-e eltárolt szám, vagy sem. És van a <varname>value</varname>,
            ami pedig egy double típusú példánytag, ez adja vissza majd a random generált számot. </para>
        <para>
            <programlisting>Random::Random() {
	exist = false;
	std::srand (std::time(NULL));
};</programlisting>
        </para>
        <para>Megírjuk a <code>Random()</code> konstruktort, amiben beállítjuk a logikai tagunk
            értékét, jelen esetben ez hamis értéket kap. Az utolsó sorban a randomolásra
            hivatkozunk. Maga a dekonstruktor megírása jelen esetben nem fontos, így ki is hagytuk. </para>
        <para>
            <programlisting>double Random::get() {
	if (!exist) {
		double u1, u2, v1, v2, w;
		do {
			u1 = std::rand () / (RAND_MAX + 1.0);
			u2 = std::rand () / (RAND_MAX + 1.0);
			v1 = 2 * u1 - 1;
			v2 = 2 * u2 - 1;
			w = v1 * v1 + v2 * v2;
		    }
		while (w > 1);
		double r = std::sqrt ((-2 * std::log (w)) / w);
		value = r * v2; 
		exist = !exist;
		return r * v1;
	}
	else {
		exist = !exist;
		return value;
	}
};

int main() {
    Random rnd;
    for (int i = 0; i &lt; 10; ++i)
    std::cout &lt;&lt; rnd.get() &lt;&lt; std::endl; 
}</programlisting>
        </para>
        <para>Itt jön az algoritmus megírása, vagyis a matematikai háttér, amit nem kell
            kirészleteznünk most. A <code>do</code> részben randomoljuk ki a két számunkat, és ahogy
            a Java verzióban, úgy itt is hasonlóan számoltatjuk ki a két számot. Az egyiket
            eltároljuk és az <varname>exist</varname> igazzá válik, így jelezve, hogy van tárolt
            adata, majd a másik számunkat adjuk át a <function>main</function> függvényben
            meghívással (<code>rnd.get()</code>). </para>
    </section>
    <section>
        <title>Homokozó</title>
        <para><emphasis>Írjuk át az első védési programot (LZW binfa) C++ nyelvről Java nyelvre,
                ugyanúgy működjön! Mutassunk rá, hogy gyakorlatilag a pointereket és referenciákat
                kell kiirtani és minden máris működik (erre utal a feladat neve, hogy Java-ban
                minden referencia, nincs választás, hogy mondjuk egy attribútum pointer, referencia
                vagy tagként tartalmazott legyen). </emphasis></para>
        <para><emphasis>Miután már áttettük Java nyelvre, tegyük be egy Java Servletbe és a
                böngészőből GET-es kéréssel (például a böngésző címsorából) kapja meg azt a mintát,
                amelynek kiszámolja az LZW binfáját. (APACHE TOMCAT) </emphasis></para>
        <para> Megoldás forrása: <link
                xlink:href="https://github.com/cziberez/aspectj/blob/master/src/main/java/udprog/vedes1/LZWBinFa.java"
            /></para>
        <para> Az LZW binfa feladatával és lehetőségeivel majdnem egy egész feladatsoron keresztül
            foglalkoztunk, így nem sok érdekesség maradt, amit erről az algoritmusról lehet
            beszélni. Viszont vannak még érdekességei, a feladat az, hogy C++ nyelvről átírjuk Java
            nyelvre. Bár az algoritmus ugyanaz, azért szintaktikai különbségek vannak, hiszen tudni
            kell, hogy a Java nyelvben nincsenek mutatók, minden referenciaként működik. Ez alapján
            próbáljuk meg átírni a kódot, amit a 6.4-es pontban találhatsz meg, ezt fogjuk átírni. A
            legkönnyebben talán úgy tudjuk ezt igazán megérteni és megtanulni, ha összehasonlítjuk a
            C++ és a Java verziót egymással. </para>
        <para>Így is néz ki a teljes átírt kód, most folytassuk a szétszedésével és az
            összehasonlítással! </para>
	<para><link
                xlink:href="/1.2.1csokor/LZWBinFa.java"
            /></para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 1.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>class LZWBinFa
{
public:
  LZWBinFa ():fa (&amp;gyoker)
  {
  }
  ~LZWBinFa ()
  {
     szabadit (gyoker.egyesGyermek ());
     szabadit (gyoker.nullasGyermek ());
  }
  void operator&lt;&lt; (char b)
  {
     if (b == '0')
     {
        if (!fa->nullasGyermek ())
        {
          Csomopont *uj = new Csomopont ('0')
          fa->ujNullasGyermek (uj);
          fa = &amp;gyoker;
        }
        else
        {
          fa = fa->nullasGyermek ();
        }
     }
     else
     {
        if (!fa->egyesGyermek ())
        {
          Csomopont *uj = new Csomopont ('1');
          fa->ujEgyesGyermek (uj);
          fa = &amp;gyoker;
        }
        else
        {
          fa = fa->egyesGyermek ();
        }
     }
    }</programlisting>
                            </entry>
                            <entry>
                                <programlisting>public class LZWBinFa {
	
  public LZWBinFa() {
      fa = gyoker;
  }

  public void Bit(char b) {
      if(b == '0') {
          if(fa.nullasGyermek() == null) {
             Csomopont uj = new Csomopont('0');
             fa.ujNullasGyermek(uj);
             fa = gyoker;
          }
          else {
             fa = fa.nullasGyermek();
          }
      }
      else {
          if(fa.egyesGyermek() == null) {
             Csomopont uj = new Csomopont('1');
             fa.ujEgyesGyermek(uj);
             fa = gyoker;
          }
          else {
             fa = fa.egyesGyermek();
          }
      }
  }</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>Első ránézésre a C++ hosszabb és bonyolultabb, ebben lehet némi igazság, hiszen
            például kivettük a Java-ból a dekonstruktort és kiszedtük a mutatókat és referenciákat.
            Például a <code>Csomopont *uj = new Csomopont()</code> példányosításból simán
                <code>Csomopont uj = new Csomopont()</code> lett, ami csak azt bizonyítja, hogy
            valójában ezektől kell nagy részt megszabadulni, hogy Java-ban is jól fusson a
            programunk. Ugyanez van a <code>&amp;</code> operátorral is, <code>fa =
                &amp;gyoker</code>-ből egyszerű <code>fa = gyoker</code> lett. Semmi bonyolult,
            semmi nehéz nincs ebben. </para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 2.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>void kiir (void)
{
    melyseg = 0;
    kiir (&amp;gyoker, std::cout);
}

/* KIVESSZÜK
int getMelyseg (void);
double getAtlag (void);
double getSzoras (void);

friend std::ostream &amp; operator&lt;&lt; 
        (std::ostream &amp; os, LZWBinFa &amp; bf)
{
    bf.kiir (os);
    return os;
} */

void kiir (std::ostream &amp; os)
{
    melyseg = 0;
    kiir (&amp;gyoker, os);
}</programlisting>
                            </entry>
                            <entry>
                                <programlisting>public void kiir() {
    melyseg = 0;
    kiir(gyoker, new PrintWriter(System.out));
}

public void kiir(PrintWriter write) {
    melyseg = 0;
    kiir(gyoker, write);
}</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>Ez a rész jelentősen csökkent, illetve újdonságot is tartalmaz. A
                <code>PrintWriter</code> egy érdekes eleme a Java nyelvnek, ezzel tudunk lényegében
            új nevet adni a kiíró függvénynek. Alapesetben a <code>System.out</code> előzményt
            használjuk, hogy valamit kiírassunk a standard outputra (nyilván utána kell pl. a
                <function>.print()</function>), az előbbi függvénnyel viszont ezt átnevezhetjük,
            jelen esetben ez a <code>write</code> nevet kapta, hogy beszédesebb legyen. Mintha
            kicsit átírnánk a nyelv szavait, hogy beszédesebb és könnyebben olvashatóbb legyen a
            programunk. Viszont nagyon fontos ennek az alkalmazásához, hogy a package és az
            osztályunk között importáljuk (<code>import java.io.PrintWriter</code>)! Ezzel
            helyettesítettük a C++-ban szereplő ostream osztályt (így lehetett volna akár a Java-ban
            write helyett os is az új név). </para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 3.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>private:
 class Csomopont
 {
   public:
    Csomopont (char b = '/'):betu (b), 
                balNulla (0), jobbEgy (0)
    {
    };
    ~Csomopont ()
    {
    };

    Csomopont *nullasGyermek () const
    {
        return balNulla;
    }

    Csomopont *egyesGyermek () const
    {
        return jobbEgy;
    }

    void ujNullasGyermek (Csomopont * gy)
    {
        balNulla = gy;
    }

    void ujEgyesGyermek (Csomopont * gy)
    {
        jobbEgy = gy;
    }

    char getBetu () const
    {
        return betu;
    }</programlisting>
                            </entry>
                            <entry>
                                <programlisting>class Csomopont {
    public Csomopont(char betu) {
        this.betu = betu;
        balNulla = null;
        jobbEgy = null;
    }
		
    Csomopont nullasGyermek() {
        return balNulla;
    }
		
    Csomopont egyesGyermek() {
        return jobbEgy;
    }
		
    public void ujNullasGyermek(Csomopont gy) {
        balNulla = gy;
    }
		
    public void ujEgyesGyermek(Csomopont gy) {
        jobbEgy = gy;
    }
		
    public char getBetu() {
        return betu;
    }

    private char betu;
    private Csomopont balNulla = null;
    private Csomopont jobbEgy = null;
};</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>Nem sok új dolog van ebben a csipetben, hiszen itt is lényegében ugyanazokat szedtük
            ki, mint előzőleg: a mutatókat, konstansokat, és persze a dekonstruktort. Ezen kívül
            minden ugyanolyan a Java verzióban is, mint a C++-ban. </para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 4.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>private:
    char betu;
    Csomopont *balNulla;
    Csomopont *jobbEgy;
    Csomopont (const Csomopont &amp;);
    Csomopont &amp; operator= (const Csomopont &amp;);
};

Csomopont *fa;
LZWBinFa (const LZWBinFa &amp;);
LZWBinFa &amp; operator= (const LZWBinFa &amp;);

void kiir (Csomopont * elem, std::ostream &amp; os)
{
    if (elem != NULL)
    {
        ++melyseg;
        kiir (elem->egyesGyermek (), os);
        for (int i = 0; i &lt; melyseg; ++i)
            os &lt;&lt; "---";
        os &lt;&lt; elem->getBetu () &lt;&lt; "(" 
           &lt;&lt; melyseg - 1 &lt;&lt; ")" &lt;&lt; std::endl;
        kiir (elem->nullasGyermek (), os);
        --melyseg;
    }
}</programlisting>
                            </entry>
                            <entry>
                                <programlisting>private Csomopont fa;
private Integer melyseg;

public void kiir(Csomopont elem, 
                PrintWriter write) {
    if(elem != null) {
        ++melyseg;
        kiir(elem.egyesGyermek(), write);
        for(int i = 0; i &lt; melyseg; ++i) {
            write.print("---");
            write.print(elem.getBetu() + "(" 
                        + melyseg - 1 + ")");
            kiir(elem.nullasGyermek(), write);
            --melyseg;
        }
    }
}</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>Az adattagokat private-ra állítjuk, illetve megírjuk a <function>kiir()</function>
            publikus függvényünket is. Ennek feladata egyértelmű: kiírja nekünk a fát formázottan,
            ahogy az a képen is látható: </para>
        <para>IDE JÖN EGY KÉP</para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 5.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>void szabadit (Csomopont * elem)
{
    if (elem != NULL)
    {
        szabadit (elem->egyesGyermek ());
        szabadit (elem->nullasGyermek ());
        delete elem;
    }
}

protected:

    Csomopont gyoker;
    int maxMelyseg;

    void rmelyseg (Csomopont * elem);

};

int
LZWBinFa::getMelyseg (void)
{
    melyseg = maxMelyseg = 0;
    rmelyseg (&amp;gyoker);
    return maxMelyseg - 1;
}

void
LZWBinFa::rmelyseg (Csomopont * elem)
{
    if (elem != NULL)
    {
        ++melyseg;
        if (melyseg > maxMelyseg)
            maxMelyseg = melyseg;
        rmelyseg (elem->egyesGyermek ());
        rmelyseg (elem->nullasGyermek ());
        --melyseg;
    }
}

void
usage (void)
{
    std::cout &lt;&lt; "Usage: lzwtree in_file -o out_file" &lt;&lt; std::endl;
}</programlisting>
                            </entry>
                            <entry>
                                <programlisting>    protected Csomopont gyoker = new Csomopont('\');
    int maxMelyseg = 0;

    public int getMelyseg() {
        melyseg = maxMelyseg;
        rmelyseg(gyoker);
        return maxMelyseg - 1;
    }
	
    public void rmelyseg (Csomopont elem) {
        if(elem != null) {
            ++melyseg;
            if(melyseg > maxMelyseg) {
                maxMelyseg = melyseg;
            }
            rmelyseg(elem.egyesGyermek());
            rmelyseg(elem.nullasGyermek());
            --melyseg;
        }
    }
	
    public static void usage() {
        System.out.println("Usage: lzwtree in_file -o out_file");
    }</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>A könyv első felében lévő LZW binfa fájlban szerepelt még szórás és átlag is, ezeket
            most inkább kihagytuk a Java verzióból, hiszen nem sok szerepük van, és az átírásuk is
            pont úgy működik, mint a mélységnél. Amit viszont bent hagytunk, az a
                <function>szabadit()</function> függvény, mert némiképp lényegesebb, hogy a Java
            kódunkba nem raktuk bele. Ez a függvény felelős azért, hogy preorder fabejárás során
            először a jobb, majd a bal ágát töröljük, "szabadítjuk fel". Ezután deklaráljuk a
            megfelelő dolgokat és itt jön egy újabb érdekes dolog: C++-ban még a függvény előtt
            deklaráltuk magán a függvényt, és csak utána írtuk meg, de Java-ban erre nincs szükség,
            utólag is megírhatjuk. A végén pedig a <function>usage()</function> függvénnyel mondjuk
            meg a felhasználónak, hogyan is kell használnia ezt a programot terminálban. </para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 5.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>int main (int argc, char *argv[])
{
    if (argc != 4)
    {
        usage ();
        return -1;
    }

    char *inFile = *++argv;

    if (*((*++argv) + 1) != 'o')
    {
        usage ();
        return -2;
    }

    std::fstream beFile (inFile, std::ios_base::in);

    if (!beFile)
    {
        std::cout &lt;&lt; inFile &lt;&lt; " nem letezik..." &lt;&lt; std::endl;
        usage ();
        return -3;
    }

    std::fstream kiFile (*++argv, std::ios_base::out);

    unsigned char b;
    LZWBinFa binFa;

    while (beFile.read ((char *) &amp;b, sizeof (unsigned char)))
        if (b == 0x0a)
            break;</programlisting>
                            </entry>
                            <entry>
                                <programlisting>public static void main(String[] args) {
    if(args.length != 4) {
        usage();
        System.exit(-1);;
    }
    String inFile = args[1];
		
    if(!"-o".equals(args[2])) {
        usage();
        System.exit(-2);
    }
    try {
        java.io.FileInputStream beFile =
            new java.io.FileInputStream
                (new java.io.File(args[1]));
        java.io.PrintWriter kiFile = 
            new java.io.PrintWriter(
                new java.io.BufferedWriter(
                    new java.io.FileWriter(args[4])));
        byte[] b = new byte[1];
        LZWBinFa binFa = new LZWBinFa();
		    
        while(beFile.read(b) != -1) {
            if(b[0] == 0x0a) {
                break;
            }
        }</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>A kódunk utolsó függvénye jön, vagyis a <function>main()</function>, amiből már jól
            látszik, hogy a Java valóban egy objektumorientált nyelv. Az első if feltételben
            meghatározzuk, hogyha nem 4 argot kap meg a program (hiszen feljebb megírtuk a program
            használatát: lzwtree in_file -o out_file, ez összesen 4 arg) hívja meg a
                <function>usage()</function> függvényünket, azaz emlékeztesse a felhasználót arra,
            hogyan is használja ezt a programot. Ezután megjegyezzük a bemeneti fájlt, és végül azt
            "-o"-t is definiáljuk, vagyis ha ez nem szerepel a használat során, akkor ismét a
                <function>usage()</function> függvényt kérjük segítségül, hogy értesítse a
            felhasználót az alkalmazás módjáról. Ezután jön a try-catch páros, viszont mivel a try
            rész igen hosszú, ketté szedtem. A try-catch fontos a Java-ban, a kivételkezelést végzi.
            Egész pontosan a try-ban szerepel a kritikuspont, ami ha nem teljesül, akkor hajtódik
            végre a catch-ban megadott hibaüzenet. Tehát olyan, mint egy if-else utasításpáros.
            Először definiáljuk a bemeneti fájlt és a kimeneti fájlt (args[1] és args[4]).
            Beolvassuk a bejövő fájl bájtjait, majd a <code>binfa</code> objektumba nyomjuk a fát. </para>
        <para>
            <table frame="all">
                <title>C++ és Java összehasonlítás 5.</title>
                <tgroup cols="2">
                    <colspec colname="c1" colnum="1" colwidth="1*"/>
                    <colspec colname="c2" colnum="2" colwidth="1*"/>
                    <thead>
                        <row>
                            <entry>C++</entry>
                            <entry>Java</entry>
                        </row>
                    </thead>
                    <tbody>
                        <row>
                            <entry>
                                <programlisting>    bool kommentben = false;

    while (beFile.read ((char *) &amp;b, sizeof (unsigned char)))
    {
        if (b == 0x3e)
        {
            kommentben = true;
            continue;
        }

        if (b == 0x0a)
        {
            kommentben = false;
            continue;
        }

        if (kommentben)
            continue;

        if (b == 0x4e)
            continue;

        for (int i = 0; i &lt; 8; ++i)
        {
            if (b &amp; 0x80)
                binFa &lt;&lt; '1';
            else
                binFa &lt;&lt; '0';
            b &lt;&lt;= 1;
        }

    }
    kiFile &lt;&lt; binFa;

    kiFile &lt;&lt; "depth = " &lt;&lt; binFa.getMelyseg () &lt;&lt; std::endl;
    kiFile &lt;&lt; "mean = " &lt;&lt; binFa.getAtlag () &lt;&lt; std::endl;
    kiFile &lt;&lt; "var = " &lt;&lt; binFa.getSzoras () &lt;&lt; std::endl;

    kiFile.close ();
    beFile.close ();

    return 0;</programlisting>
                            </entry>
                            <entry>
                                <programlisting>    boolean kommentben = false;

    while(beFile.read(b) != -1) {
        if(b[0] == 0x3e) { //> karakter
            kommentben = true;
            continue;
        }
        if(b[0] == 0x0a) { //ujsor
            kommentben = false;
            continue;
        }
        if(kommentben) {
            continue;
        }
        if(b[0] == 0x4e) { //N betu
            continue;
        }
		    	
        for(int i = 0; i &lt; 8 ; ++i) {
            if((b[0] &amp; 0x80) != 0) {
                binFa.egyBitFeldolg('1');
            } 
            else {
                binFa.egyBitFeldolg('0');
            }
            b[0] &lt;&lt;= 1;
        }
    }
    binFa.kiir(kiFile);
    kiFile.println("depth = " + binFa.getMelyseg());

    kiFile.close();
    beFile.close();
}
catch (java.io.FileNotFoundException fnfException) {
    fnfException.printStackTrace();
} 
catch (java.io.IOException ioException) {
    ioException.printStackTrace();
}</programlisting>
                            </entry>
                        </row>
                    </tbody>
                </tgroup>
            </table>
        </para>
        <para>A try ág második fele, ahol deklaráltunk egy <code>kommentben</code> boolean típusú
            változót, aztán megnyitunk egy while ciklust, ami egészen a fa végéig fut majd. A végén
            bittologatás történik, azaz egyesével végig nézzük a <code>b</code> bitjeit, és az if
            utasítás fejrészében a legmagasabb helyiértékű bit vizsgálatát kérjük. Csupa 0 lesz
            benne, a kérdés viszont az, hogy a végén 0 vagy 1 lesz, erre ad igazából nekünk választ
            az utasítás. Ha 1, akkor azt nyomjuk az LZW fa objektumunkba, egyébként a nullát. Végül
            kiíratjuk a fát, vele együtt a mélységét, aztán bezárjuk a kimeneti és a bemeneti fájlt
            is. Ez utóbbi nagyon fontos, ha nem akarunk problémákal szembe találkozni a program
            futása során. Végén két catch ágat jelenítunk meg, amik a különböző exception hibák
            esetén ad ki jelzést, például ha a fájlt nem találja. </para>
    </section>
    <section>
        <title>"Gagyi"</title>
        <para><emphasis>Az ismert formális „while (x &lt;= t &amp;&amp; x >= t &amp;&amp; t != x);”
                tesztkérdéstípusra adj a szokásosnál (miszerint x, t az egyik esetben az objektum
                által hordozott érték, a másikban meg az objektum referenciája) „mélyebb” választ,
                írj Java példaprogramot mely egyszer végtelen ciklus, más x, t értékekkel meg nem! A
                példát építsd a JDK Integer.java forrására3, hogy a 128-nál inkluzív objektum
                példányokat poolozza!</emphasis></para>
        <para> Megoldás forrása: <link
                xlink:href="https://www.facebook.com/groups/udprog/permalink/437825193072042/?comment_id=437862206401674&amp;reply_com%20ment_id=437863669734861&amp;comment_tracking=%7B%22tn%22%3A%22R3%22%7D"
            /></para>
        <para> Ez a feladat egy tipikus Java feladat, ugyanis ennek a nyelvnek egy érdekességével
            foglalkozik. Ehhez viszont előbb meg kell néznünk, hogyan is működik az egyenlőség két
            objektum között. Kétféle egyenlőség létezik, az egyik az érték szerinti, ami elég
            egyértelmű fogalom, nem kell kifejteni, a másik pedig azonosságon alapul, azaz a két
            dolog, amit összehasonlítunk, az egy és ugyanaz minden szempontból. És most ezekre
            fogunk két példát nézni, amikor <code>x</code> és <code>t</code> ugyanolyan értékűek, de
            egyik esetben véges ciklus, másik esetben végtelen ciklus alakul ki. Nézzük is meg
            ezeket, és akkor egy kis magyarázatot is adok, ez hogyan lehetséges és milyen értékek
            esetén tudsz te is ilyet előállítani. </para>
        <para>Kezdjünk a véges ciklussal: </para>
        <para>
            <programlisting>public class gagyi-1 {

    public static void main (String[]args) {

        Integer x = 127;
        Integer t = 127;

        System.out.println (x);
        System.out.println (t);
 
         while (x&lt;=t &amp;&amp; x>=t &amp;&amp; t!=x) {
            System.out.println("A végtelenbe és tovább.");
        }
     } 
}</programlisting>
        </para>
        <para>Ha lefuttatjuk a programot, akkor nem fog belépni a program, nem fogja nekünk kiírni a
            "végtelenbe és tovább" szöveget, ennek megvan a nyomós indoka, és ezért az Integer
            osztályunkat kell alaposan szemügyre vennünk. Tudni kell, hogy az osztály gyorsítótáraz
            egy bizonyos intervallumot, ez pedig a -128-tól a +127-ig tartó intervallum, ezért a 
	    <code>t!=x</code> rész megbukik, és ezért nem teljesül a fejrész.</para>
        <para>És most folytassuk a végtelen ciklussal: </para>
        <para>
            <programlisting>public class gagyi-1 {

    public static void main (String[]args) {

        Integer x = 128;
        Integer t = 128;

        System.out.println (x);
        System.out.println (t);
 
         while (x&lt;=t &amp;&amp; x>=t &amp;&amp; t!=x) {
            System.out.println("A végtelenbe és tovább.");
        }
     } 
}</programlisting>
        </para>
        <para>A programunk soha nem fog leállni, pont emiatt végtelen ciklus. Ennek azaz oka, hogy a
            128 már kívül esik a gyorsítótár intervallumán, így a fejrész elemei mind teljesülnek.
            Hiszen <code>x</code> és <code>t</code> mindig egyenlőek lesznek, így az első két
            feltétel megvalósul, az utolsó pedig lényegében azért lesz igaz, mivel két változót
            hoztunk létre, azaz a kettő soha nem lesz ugyanaz, képtelenség a memóriában egyidőben
            ugyanazon a helyen két dolgot tárolni. Vagyis itt pont nem az érték szerinti
            összehasonlítás történik, ami esetén nyilván nem teljesülne a dolog, hanem azt nézi,
            hogy két különböző hely lett lefoglalva, így nem egyenlőek. </para>
    </section>
    <section>
        <title>Yoda</title>
        <para><emphasis>Írjunk olyan Java programot, ami java.lang.NullPointerEx-el leáll, ha nem
                követjük a Yoda conditions-t! Segítség: <link
                    xlink:href="https://en.wikipedia.org/wiki/Yoda_conditions"/></emphasis></para>
        <para> Megoldás forrása: </para>
        <para> A Yoda feltétel érdekes, és bár nem használatos az általános programozásban, kicsit
            tanulmányozni és tudni róla ezt-azt, érdemes. Röviden összefoglalva a feltételünk
            fejrészét fordítjuk meg. A nevét a Star Wars híres karakteréről, Yoda mesterről kapta,
            aki nem éppen hagyományos szintaxisban beszélt, ha nem is pontosan visszafele, de nem is
            egyenesen, ahogy az normális. Egy egyszerű, C++-os példával valahogy így nézne ki a
            dolog megvalósítása a programozásban: </para>
        <para>
            <programlisting>//EREDETI MEGOLDÁS
if(a > 5)

//YODA MEGOLDÁS
if(5 &lt; a)</programlisting>
        </para>
        <para>Nem bonyolult dolog, de az érdekessége akkor látszódik, ha kicsit belegondolunk ennek
            a hátterébe. A feladatunk például most pont az, hogy olyan Java csipetet írjunk, amiben
            a feltétel nem fordul le úgy, hogy nem a Yoda feltételt követi. Vagyis ezzel
            bizonyíthatjuk azt, hogy ilyen problémákat megoldhatunk ennek a programozási stílusnak
            az ismeretével. Ami még pluszba érdekes, hogy a Symfony és a WordPress kódolási
            szabványok alkalmazzák ezt a technikát. Na de akkor íme a kód, ami bizonyítja a feljebb
            lévő állítást: </para>
        <para>
            <programlisting>public class Yoda {

    public static void main(String[] args){

        String szoveg = null;

        //if(szoveg.equals("yoda")) { NullPointerException-t kapunk
        if("yoda".equals(szoveg) {    //lefut, de nem irja ki a kert szoveget
            System.out.println("Itt van Yoda");
        }
    }
}</programlisting>
        </para>
        <para>Ahogy látható, a felső sor hibát adna ki, ha így használnánk, egész pontosan
            NullPointerExceptiont ad ki. A második esetben már lefut a program, nem észlel hibát, de
            nyilván nem fogja kiírni a szöveget. Ez talán úgy lenne még szemléletesebb, ha egy
            try-catch párost használnánk és beállítanánk, ha nem jó a try-ban lévő feltétel, akkor
            írjon ki hibát. Természetesen az első megoldás esetében jelezné azonnal, a második
            esetében viszont nem, hiszen valójában nem a program által értelmezhetetlen gond merült
            fel, csak egyszerűen a <code>null</code> nem egyenlő a "yoda" szóval. </para>
    </section>
    <section>
        <title>Kódolás from scratch</title>
        <para><emphasis>Induljunk ki ebből a tudományos közleményből: <link
                    xlink:href="https://www.davidhbailey.com/dhbpapers/bbp-alg.pdf"/> és csak ezt
                tanulmányozva írjuk meg Java nyelven a BBP algoritmus megvalósítását!
            </emphasis></para>
        <para> Megoldás forrása: <link
                xlink:href="https://www.tankonyvtar.hu/hu/tartalom/tkt/javat-tanitok-javat/apas03.html"
            /></para>
        <para> A Bailey-Borwein-Plouffe algoritmus a BBP formulán alapul, amit még 1995-ben fedeztek
            fel, de csak 1996-ban publikálták. A formula jelenleg talán a leggyorsabb módszer,
            amivel ki tudjuk számoltatni a géppel a Pi értékét bármennyi pontossággal. Egyik érdekes
            tulajdonsága, hogy elérhetővé teszi egy kiszámításához tetszőleges kiindulási helyzetben
            lévő kezdeti hexadecimális vagy bináris számjegyeket. Lényegében egy spigot algoritmust
            ad, ugyanis a π egy tetszőlegesen kért számjegyét kérhetjük vissza hexadecimális
            formában anélkül, hogy az előző számjegyeket kiszámolnánk. Sokáig azonban az élt a
            köztudatban, hogy ennek az n-edik számnak a kiszámolása ugyan annyira nehéz, mintha az
            első n számjegyet számoltatnánk ki. Ez azóta meg lett cáfolva, sőt az algoritmus
            futtatása során az időt is szoktuk figyelni, hogy aztán összehasonlítsuk a más nyelveken
            megvalósított változatokkal. De mi most csak a Java-ban írjuk meg, viszont a következő
            leckében meg fogjuk vizsgálni, hogy az egyes nyelveken mennyi idő alatt fut le ez az
            algoritmus.
            <programlisting>/*
 * PiBBPBench.java
 *
 * DIGIT 2005, Javat tanítok
 * Bátfai Norbert, nbatfai@inf.unideb.hu
 *
 */
/**
 * A PiBBP.java-ból kivettük az "objektumorientáltságot", így kaptuk
 * ezt az osztályt.
 *
 * (A PiBBP osztály a BBP (Bailey-Borwein-Plouffe) algoritmust a Pi hexa
 * jegyeinek számolását végző osztály. A könnyebb olvahatóság
 * kedvéért a változó és metódus neveket megpróbáltuk az algoritmust
 * bemutató [BBP ALGORITMUS] David H. Bailey: The BBP Algorithm for Pi.
 * cikk jelöléseihez.)
 *
 * @author Bátfai Norbert, nbatfai@inf.unideb.hu
 * @version 0.0.1
 */

public class PiBBPBench {
    public static double d16Sj(int d, int j) {
        
        double d16Sj = 0.0d;
        
        for(int k=0; k&lt;=d; ++k)
            d16Sj += (double)n16modk(d-k, 8*k + j) / (double)(8*k + j);
        return d16Sj - Math.floor(d16Sj);
    }

    public static long n16modk(int n, int k) {
        
        int t = 1;
        while(t &lt;= n)
            t *= 2;
        
        long r = 1;
        
        while(true) {
            
            if(n >= t) {
                r = (16*r) % k;
                n = n - t;
            }
            
            t = t/2;
            
            if(t &lt; 1)
                break;
            
            r = (r*r) % k;
            
        }
        
        return r;
    }

    public static void main(String args[]) {
        
        double d16Pi = 0.0d;
        
        double d16S1t = 0.0d;
        double d16S4t = 0.0d;
        double d16S5t = 0.0d;
        double d16S6t = 0.0d;
        
        int jegy = 0;
        
        long delta = System.currentTimeMillis();
        
        for(int d=1000000; d&lt;1000001; ++d) {
            
            d16Pi = 0.0d;
            
            d16S1t = d16Sj(d, 1);
            d16S4t = d16Sj(d, 4);
            d16S5t = d16Sj(d, 5);
            d16S6t = d16Sj(d, 6);
            
            d16Pi = 4.0d*d16S1t - 2.0d*d16S4t - d16S5t - d16S6t;
            
            d16Pi = d16Pi - Math.floor(d16Pi);
            
            jegy = (int)Math.floor(16.0d*d16Pi);
            
        }
        
        System.out.println(jegy);
        delta = System.currentTimeMillis() - delta;
        System.out.println(delta/1000.0);
    }
} </programlisting></para>
        <para>Nem ez nehéz, bonyolult vagy hosszú programról van szó, nem lesz probléma a
            megértésével, főleg ha előttünk van magának az algoritmusnak a levezetése: </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="1.2.1csokor/bbp-alg.png" scale="90"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
        <para>Így, hogy előttünk van a megoldókulcs, igazából már nem lesz olyan nehéz megérteni a
            kódunkat. Három részre osztva ki is fejtem, melyik rész mit csinál. </para>
        <para>
            <programlisting>public static double d16Sj(int d, int j) {
        
        double d16Sj = 0.0d;
        
        for(int k=0; k&lt;=d; ++k)
            d16Sj += (double)n16modk(d-k, 8*k + j) / (double)(8*k + j);
        return d16Sj - Math.floor(d16Sj);
    }</programlisting>
        </para>
        <para>A <code>d16Sj</code> nevezetű függvényünkben meghívunk segítségül két
                <varname>int</varname> változót, <code>d</code> és <code>j</code> néven. Ami igazán
            érdekes, és C++ nyelvben nem találkoztunk ilyennel az a <code>0.0d</code> rész. Ez
            egyszerűen ugyanazt jelenti, mintha simán 0.0-t írtunk volna, csupán a d betű a
                <varname>double</varname> jelöli. A lebegőpontos változóknál volt ez régebben
            használatos, tehát ha <varname>float</varname>-ot használunk, akkor d helyett f betűt
            kéne használnunk. Szerencsére viszont ezt már kivették a Java-ból, de hasznos
            elraktározni ezt az információt, mert régi kódoknál még találkozhatunk ezzel. Ezután egy
            for ciklusban, amíg el nem érjük a d értéket, illetve még azzal megegyezően is
            végrehajtjuk a feladatot. A deklarált <code>d16Sj</code> kap értéket és találkoztunk a
            += operátorral, ami eddig még nem nagyon tűnt fel a könyv során, de amúgy egy alap
            műveletet hajt végre. Egy egyszerű példában az <code>x += y</code> kifejezés valójában
            azt jelenti, hogy <code>x = x + y</code>. A mi esetünkben tehát a lebegőpontos
            értékünkhöz valójában hozzáadtuk a fenti műveletet, kasztolással. Az utolsó sorban
            (mivel egy függvényt írtunk ugyebár) értéket adunk vissza, méghozzá úgy, hogy újabb
            függvénnyel ismerkedhetünk meg: a <function>floor()</function> metódussal, ami annyit
            jelent, hogy az adott értéknél kisebb vagy egyenlő számok közül a legnagyobbat adja
            vissza, kerekítve (nyilván double érték miatt a vége .0 lesz). </para>
        <para>
            <programlisting>    public static long n16modk(int n, int k) {
        
        int t = 1;
        while(t &lt;= n)
            t *= 2;
        
        long r = 1;
        
        while(true) {
            
            if(n >= t) {
                r = (16*r) % k;
                n = n - t;
            }
            
            t = t/2;
            
            if(t &lt; 1)
                break;
            
            r = (r*r) % k;
            
        }
        
        return r;
    }</programlisting>
        </para>
        <para>A második rész is egy függvény, amiben szintén két <varname>int</varname> típusú
            változót fogunk felhasználni, az <code>n</code>-t és a <code>k</code>-t, ahol az előbbi
            a kitevő, az utóbbi a modulus. Ezek azért lényegesek, ugyanis ebben a részben történik a
            bináris hatványozás, vagyis a 16<superscript>n</superscript> mod k kiszámítása, erre utal a függvény neve is. A
                <varname>long</varname> nem lehet ismeretlen, ez egy szám típusú változó és szerepe
            abban van, amiről a neve is beszél: 8 bájtos mérete van, ami ennél a feladatnál nagyon
            hasznos, biztonságosabb ennek a használata. Ami még ennek a résznek egy kulcsfontosságú
            eleme, azaz <code>r=(16*r)%k</code> rész. Itt határozzuk meg, hogy a 16 hatványainak
            maradékai közül azokat akarjuk, amelyeket a <code>k</code>-val való osztás után
            kaphatunk meg. </para>
        <para>
            <programlisting>    public static void main(String args[]) {
        
        double d16Pi = 0.0d;
        
        double d16S1t = 0.0d;
        double d16S4t = 0.0d;
        double d16S5t = 0.0d;
        double d16S6t = 0.0d;
        
        int jegy = 0;
        
        long delta = System.currentTimeMillis();
        
        for(int d=1000000; d&lt;1000001; ++d) {
            
            d16Pi = 0.0d;
            
            d16S1t = d16Sj(d, 1);
            d16S4t = d16Sj(d, 4);
            d16S5t = d16Sj(d, 5);
            d16S6t = d16Sj(d, 6);
            
            d16Pi = 4.0d*d16S1t - 2.0d*d16S4t - d16S5t - d16S6t;
            
            d16Pi = d16Pi - Math.floor(d16Pi);
            
            jegy = (int)Math.floor(16.0d*d16Pi);
            
        }
        
        System.out.println(jegy);
        delta = System.currentTimeMillis() - delta;
        System.out.println(delta/1000.0);
    }
} </programlisting>
        </para>
        <para>És végül a main rész, ahol meghívjuk a függvényeket, elvégeztetjük a számolást és
            természetesen kiíratjuk a végeredményt. Ezért a for ciklus felelős, ahol a függvényeknek
            értékeket adunk (1,4,5,6), illetve a <code>d</code> "megadásával (hiszen csak egyszer
            fog lefordulni a ciklus) pedig megmondjuk, hogy minket a 10<superscript>6</superscript>
            számjegy fog érdekelni. Kiszámoltatjuk ezt a jegyet, és közben egy újabb, eddig még
            ismeretlen elemmel találkozhatunk a kódban: a <code>System.currentTimeMillis()</code>
            függvény. Ahogy az elején említettem, szeretnénk tudni, hogy mennyi idő alatt számolja
            ki a program ezt az értéket, és ezért ez a függvény felelős, ami milliszekundumban adja
            meg az aktuális időt. Ezután pedig kiíratjuk a kiszámolt jegy mellé ezt az időt is. </para>

    </section>
</chapter>                
